SIMVoleon: SoVolumeRendering Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://bitbucket.org/Coin3D/ http://www.kongsberg.com/kogt/

SoVolumeRendering Class Reference

Abstract base class for all nodes related to volume rendering. More...

`#include <VolumeViz/nodes/SoVolumeRendering.h>`

Inheritance diagram for SoVolumeRendering:

## Public Types
enum | HW_Feature { HW_VOLUMEPRO , HW_3DTEXMAP , HW_TEXCOLORMAP , HW_TEXCOMPRESSION }
enum | HW_SupportStatus { NO , YES , UNKNOWN }

## Public Member Functions
HW_SupportStatus | isSupported (HW_Feature feature)

## Static Public Member Functions
static void | init (void)
static void | initClass (void)
static void | setReadAlternateRep (SbBool flag)
static void | setWriteAlternateRep (SbBool flag)
static SbBool | getReadAlternateRep (void)
static SbBool | getWriteAlternateRep (void)
static void | setDelayedRendering (SbBool flag)
static SbBool | getDelayedRendering (void)

## Friends
class | SoVolumeRenderingP

## Detailed Description

Abstract base class for all nodes related to volume rendering.

The sole purpose of this class is really just to initialize the volume rendering framework, and to provide a convenient method for the application programmer to make queries about the capabilities of the underlying visualization library.

This class should never have been a node class, as it has no distinguishing features in that regard. We duplicate this design flaw for the sake of being compatible with code written for the TGS VolumeViz extension library.

## Member Function Documentation

## ◆ init()

void SoVolumeRendering::init | ( | void |  | ) |
| static

Does all necessary class initializations of the volume rendering system.

Application programmers must call this method explicitly at the start of the application, before any volume rendering nodes are made. It must be invoked after SoXt::init() / SoQt::init() / SoWin::init(), though.

References initClass().

## ◆ initClass()

void SoVolumeRendering::initClass | ( | void |  | ) |
| static

Sets up initialization for data common to all instances of this class, like submitting necessary information to the type system.

Referenced by init().

## ◆ setReadAlternateRep()

void SoVolumeRendering::setReadAlternateRep | ( | SbBool | flag | ) |
| static

If this flag is set, alternate representation for SIM Voleon nodes will be imported and used in the scene graph, if they are present in the import file.

If the flag is `FALSE`, alternate representations will be discarded upon import.

Default value is `FALSE`.

Since
  SIM Voleon 2.0

## ◆ setWriteAlternateRep()

void SoVolumeRendering::setWriteAlternateRep | ( | SbBool | flag | ) |
| static

If this flag is set, some of the SIM Voleon nodes will write themselves (upon SoWriteAction traversal) as an alternative representation in the form of only core Coin nodes – typically as textures (SoTexture2 / SoTexture3) and facesets (e.g. SoIndexedFaceSet).

If the flag is `FALSE`, the node will write itself as is common, i.e. only as itself, with its own fields.

Default value is `FALSE`.

Since
  SIM Voleon 2.0

## ◆ getReadAlternateRep()

SbBool SoVolumeRendering::getReadAlternateRep | ( | void |  | ) |
| static

Returns value of the "read as alternative representation" flag.

See also
  SoVolumeRendering::setReadAlternateRep

Since
  SIM Voleon 2.0

## ◆ getWriteAlternateRep()

SbBool SoVolumeRendering::getWriteAlternateRep | ( | void |  | ) |
| static

Returns value of the "write as alternative representation" flag.

See also
  SoVolumeRendering::setWriteAlternateRep

Since
  SIM Voleon 2.0

## ◆ setDelayedRendering()

void SoVolumeRendering::setDelayedRendering | ( | SbBool | flag | ) |
| static

When set to `TRUE`, this will cause all geometry from the volume render nodes to be rendered as if they are all (partly) transparent.

This makes it more likely that other geometry in the scene graph which is further away from the camera than the volume(s) will be rendered correctly. When `FALSE`, there is the chance that other geometry will be occluded by even fully transparent parts of the volume(s).

Default value is `FALSE`.

Important implementation note: this flag is as of yet ignored in SIM Voleon, and is currently only present for compatibility reasons. SIM Voleon always renders geometry as if it is transparent, even if this flag is `FALSE`.

Since
  SIM Voleon 2.0

## ◆ getDelayedRendering()

SbBool SoVolumeRendering::getDelayedRendering | ( | void |  | ) |
| static

Returns value of the flag indicating whether or not to always to delayed rendering of geometry used for visualizing the volume(s).

The documentation for this class was generated from the following files:

- SoVolumeRendering.h
- VolumeRendering.cpp